#!/bin/sh

# lh_binary_usb-hdd(1) - build binary usb-hdd image
# Copyright (C) 2006-2008 Daniel Baumann <daniel@debian.org>
#
# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
# This is free software, and you are welcome to redistribute it
# under certain conditions; see COPYING for details.

set -e

# Including common functions
LH_BASE="${LH_BASE:-/usr/share/live-helper}"

for FUNCTION in "${LH_BASE}"/functions/*.sh
do
	. "${FUNCTION}"
done

# Setting static variables
DESCRIPTION="build binary image"
HELP=""
USAGE="${PROGRAM} [--force]"

Arguments "${@}"

# Reading configuration files
Read_conffile config/all config/common config/bootstrap config/chroot config/binary config/source
Set_defaults

if ! echo "${LH_BINARY_IMAGES}" | grep -qs usb-hdd
then
	exit 0
fi

Echo_message "Begin building binary usb-hdd image..."

# Requiring stage file
Require_stagefile .stage/bootstrap
Require_stagefile .stage/chroot_proc

# Checking stage file
Check_stagefile .stage/binary_usb-hdd

# Checking lock file
Check_lockfile .lock

# Creating lock file
Create_lockfile .lock

# Checking depends
Check_package chroot/sbin/mkdosfs dosfstools
Check_package chroot/usr/share/doc/mtools mtools
Check_package chroot/sbin/parted parted

case "${LH_BOOTLOADER}" in
	grub)
		Check_package chroot/usr/sbin/grub grub
		;;

	syslinux)
		Check_package chroot/usr/bin/syslinux syslinux
		;;
esac

# Restoring cache
Restore_cache cache/packages_binary

# Installing depends
Install_package

# Remove old binary
if [ -f binary.img ]
then
	rm -f binary.img
fi

# Everything which comes here needs to be cleaned up,
DU_DIM="$(du -ms binary | cut -f1)"
REAL_DIM="$(expr ${DU_DIM} + ${DU_DIM} / 50 + 1)" # Just 2% more to be sure, need something more sophistcated here...
dd if=/dev/zero of=chroot/binary.img bs=1024k count=0 seek=${REAL_DIM}
FREELO="$(${LH_LOSETUP} -f)"
if [ ! -b chroot/${FREELO} ]
then
	MAKEDEV="true"

	mv chroot/dev chroot/dev.tmp
	find /dev | cpio -dmpu chroot
fi

echo "!!! The following error/warning messages can be ignored !!!"
Losetup $FREELO chroot/binary.img 0

case "${LH_CHROOT_BUILD}" in
	enabled)
		Chroot "parted -s ${FREELO} mklabel msdos" || true
		Chroot "parted -s ${FREELO} mkpart primary ${LH_BINARY_FILESYSTEM} 0.0 100%" || true
		Chroot "parted -s ${FREELO} set 1 boot on" || true
		Chroot "parted -s ${FREELO} set 1 lba off" || true

		if [ "${LH_BOOTLOADER}" = "syslinux" ]
		then
			cat chroot/usr/lib/syslinux/mbr.bin > ${FREELO}
		fi
		;;

	disabled)
		parted -s ${FREELO} mklabel msdos || true
		parted -s ${FREELO} mkpart primary ${LH_BINARY_FILESYSTEM} 0.0 100% || true
		parted -s ${FREELO} set 1 boot on || true
		parted -s ${FREELO} set 1 lba off || true

		if [ "${LH_BOOTLOADER}" = "syslinux" ]
		then
			cat /usr/lib/syslinux/mbr.bin > ${FREELO}
		fi
		;;
esac

${LH_LOSETUP} -d ${FREELO}

FREELO="$(${LH_LOSETUP} -f)"
Losetup $FREELO chroot/binary.img 1

case "${LH_BINARY_FILESYSTEM}" in
	fat16)
		MKFS_OPTIONS="-F 16"
		;;

	fat32)
		MKFS_OPTIONS="-F 32"
		;;
esac

case "${LH_CHROOT_BUILD}" in
	enabled)
		Chroot "mkfs.vfat ${MKFS_OPTIONS} -n DEBIAN_LIVE ${FREELO}"
		;;

	disabled)
		mkfs.vfat ${MKFS_OPTIONS} -n DEBIAN_LIVE ${FREELO}
		;;
esac

mkdir -p chroot/binary.tmp
${LH_ROOT_COMMAND} mount ${FREELO} chroot/binary.tmp
cp -rL binary/* chroot/binary.tmp

FIXME()
{
if [ "${LH_BOOTLOADER}" = "grub" ]
then

cat > chroot/grub.sh << EOF
cd binary.tmp
grub --batch << EOM
find /live/vmlinuz
EOM
EOF

	rootpartition="$(Chroot 'sh grub.sh' 2>/dev/null | grep -A 1 'find /live/vmlinuz' | grep -v 'find /live/vmlinuz')"
	usbdev="$(echo $rootpartition | sed -e 's|,[[:digit:]]||')"
	echo "Root partition is $rootpartition, device is: $usbdev"

	echo "WAITING..." && read WAIT

#cat > chroot/grub.sh << EOF
#grub --batch << EOM
#root $rootpartition
#setup $usbdev
#EOM
#EOF

#Chroot "sh grub.sh"

	rm -f chroot/grub.sh
fi
}

${LH_ROOT_COMMAND} umount chroot/binary.tmp
rmdir chroot/binary.tmp

if [ "${LH_BOOTLOADER}" = "syslinux" ]
then
	case "${LH_CHROOT_BUILD}" in
		enabled)
			Chroot "syslinux ${FREELO}"
			;;

		disabled)
			syslinux ${FREELO}
			;;
	esac
fi

${LH_LOSETUP} -d ${FREELO}

echo "!!! The above error/warning messages can be ignored !!!"

if [ -n "${MAKEDEV}" ]
then
	rm -rf chroot/dev
	mv chroot/dev.tmp chroot/dev
fi

mv chroot/binary.img ./

# Saving cache
Save_cache cache/packages_binary

# Removing depends
Remove_package

# Creating stage file
Create_stagefile .stage/binary_usb-hdd
